<template>
  <el-container style="flex-grow:1">
    <el-main class="containMain">
      <div class="contentTitle">转场登记</div>
      <el-form ref="form" :model="formData" label-width="80px" style="margin-top:20px;">
        <el-form-item label label-width="0">
          <el-autocomplete prefix-icon="el-icon-search" v-model="formData.cowID" :fetch-suggestions="queryCow" placeholder="请输入牛号" style="width:300px" clearable @select="getNowCow"></el-autocomplete>
        </el-form-item>
        <div class="sub" v-if="tableData.length>0">操作牛号：{{tableData[0].value}}</div>
        <el-form-item label="目标牧场">
          <el-select v-model="formData.currFarm" placeholder="请选择目标牧场">
            <el-option v-for="item in farmList" :key="item['牧场编号']" :label="item['牧场名称']" :value="item['牧场编号']"></el-option>
          </el-select>
        </el-form-item>

        <div style="margin-top:80px">
          <el-button @click="onSave" type="primary" style="width:98px;" size="mediu">确认转场</el-button>
        </div>
      </el-form>
    </el-main>
    <el-aside class="containAside" width="450px">
      <div class="asideInfo">
        <div class="contentTitle">牛只信息</div>
        <el-table class="handleTable" border :data="tableData" style="width: 100%" :height="(allHeight-70)+'px'" size="small">
          <el-table-column prop="key" label="参数"></el-table-column>
          <el-table-column prop="value" label="当前牛只信信息"></el-table-column>
        </el-table>
      </div>
    </el-aside>
  </el-container>
</template>
<script>
import formValidator from '../formValidator'
import axios from 'axios'
import { mapState } from 'vuex'
export default {
  created() {

    this.getHaleInfo('wsCow', 'getAllFarm', [], 'list').then((data) => {
      this.farmList = data
    })


  },
  data() {
    return {
      saving: false,
      formData: {
        cowID: '',
        currFarm: '',
      },
      tableData: [],
      farmList: [],
      editInfo: {}
    }
  },
  computed: {
    ...mapState(['userInfo', 'allHeight']),

  },
  watch: {

  },
  methods: {
    onSave() {
      if (this.formData.cowID != this.editInfo['牛号']) {
        this.$message({
          message: '请录入离场牛只牛号',
          type: 'warning'
        });
        return
      }
      if (!this.formData.currFarm) {
        this.$message({
          message: '请选择目标牧场',
          type: 'warning'
        });
        return
      }

      this.getHaleInfo('wsCow', 'updateCurrFarm', [this.formData.currFarm, this.formData.cowID], 'json').then((data) => {
        console.log(data)
        if (data.rtnCode == -1) {

          this.$alert(data.rtnMessage, '提示', {
            confirmButtonText: '确定',
            callback: action => {
              this.formData.cowID = ''
            }
          });
        }
        else {
          this.$message({
            message: '转场信息录入成功',
            type: 'success'
          });
          this.formData.cowID = ''
        }
      })



    },
    submit() {
      var data = JSON.parse(JSON.stringify(this.formData));
      this.$http.post({
        url: this.formData.id ? '/userInfo/update' : '/userInfo/save',
        data: data
      }).then(res => {
        if (res.success) {
          this.$message.success('成功');
          this.$router.go(-1);
        } else {
          this.$message.warning('失败')
        }
      });
    },
    getNowCow() {

      this.getCowInfo(this.formData.cowID).then((data) => {
        // console.log(data)
        if (data['是否在场'] == '否') {
          this.$message({
            message: '当前牛只并不在场',
            type: 'warning'
          });
          this.formData.cowID = ''
          return
        }

        if (data['当前牧场'] != this.$store.state.farmName) {
          this.$message({
            message: '牛只不属于你所在的牧场，无权转牛',
            type: 'warning'
          });
          this.formData.cowID = ''
          return
        }
        var list = []
        Object.keys(data).forEach(item => {
          list.push({
            key: item,
            value: data[item]
          })
        })

        this.editInfo = data

        // console.log(list)

        this.tableData = list
      }).catch(() => {
        this.formData.cowID = ''
      })
    }
  }
}
</script>
<style lang="less" scoped>
.containMain {
  background: rgba(255, 255, 255, 1);
  border-radius: 4px;
  padding: 15px;
  // margin-right: 10px;
  .contentTitle {
    border-bottom: 1px solid #f2f4f5;
  }
  // min-width: 450px;

  .sub {
    font-size: 14px;
    font-weight: 600;
    color: rgba(102, 102, 102, 1);
    line-height: 20px;
    margin-bottom: 40px;
    padding-left: 20px;
  }
}

.contentTitle {
  font-size: 16px;
  font-weight: bold;
  color: rgba(0, 0, 0, 1);
  line-height: 22px;
  letter-spacing: 1px;
  padding-bottom: 14px;
}

.containAside {
  padding: 0;
  margin-left: 10px;
  display: flex;
  flex-direction: column;
  .asideInfo {
    flex-grow: 1;
    background: rgba(255, 255, 255, 1);
    border-radius: 4px;
    padding: 15px;
  }
}
</style>
